// Kyle Burmark
// 4/19/02
// Prof. Gelotte
// Program 2: Airline Program
// Description: This program is a simple airline reservation system
// It allows the user to enter a name on 4 different flights, you can
// also delete, list and see how many people are on a flight, etc.



// Header files

#include <iostream>		// Standard header file
#include <string>		// String functions
#include <cctype>		// Character functions
#include "list.h"		// My header file

using namespace std;		// Standard namespace


void instruct ();			    // Instruct user
string uppercase (string wholename);	    // Make string uppercase
inline istream& Flush (istream& stream);    // Flush cin

///////////////////////// Main program ///////////////////////////////

int main ()
{
    char choice;	    // Users menu choice
    int menu = 0;	    // Menu flag exit variable
    int num;		    // Flight number user enters
    int counter = 0;	    // Counter for loop
    string firstname;	    // Passengers first name
    string lastname;	    // Passengers last name
    string wholename;	    // Whole name
    
    list flight[4];	    // Initialize 4 flights as class object
			    // array
    
    instruct();		    // Show title and instructions
    cout << endl << endl;
    system("pause");	    // Pause program
    system("cls");	    // Clear the screen
    
    // Main program and menu selection loop

    do {		// while menu != 1
	
	// Show menu
	
	cout << "                 Menu" << endl << endl
	    << "Enter 'A' to add a person to a flight" << endl << endl
	    << "Enter 'D' to delete a person from a flight" << endl << endl
	    << "Enter 'L' to list all passengers on a flight" << endl << endl
	    << "Enter 'I' to see how many passengers are on a flight" << endl << endl
	    << "Enter 'S' to see all flights" << endl << endl
	    << "Enter 'Q' to quit" << endl << endl << endl;
	
	cout << "Enter choice: ";
	cin >> choice;
	
	// Test for bad data
	
	while (!cin)
	{
	    system ("cls");
	    Flush (cin);
	    cout << "Enter choice again: ";
	    cin >> choice;
	}
	
	// end test

	system ("cls");
	
	// Switch to test for choice
	
	switch(toupper(choice))
	{
	case 'A':   // Add name to flight
	    cout << "What flight (1 - 4) : ";
	    cin >> num;
	    
	    // Test for bad data
	    
	    while (!cin || (num < 1 || num > 4))
	    {
		Flush(cin);
		cout << "Enter flight (1 - 4) : ";
		cin >> num;
	    }
	    
	    // End check

	    cout << endl << endl << "Enter name of passenger" << endl
		<< "First name: ";
	    cin.ignore(80, '\n');
	    getline(cin, firstname);
	    if (firstname.at(firstname.length() - 1) == '\n')
		firstname.erase(firstname.length() - 1, 1);
	    cin.ignore(80, '\n');
	    cout << "Last name : ";
	    getline(cin, lastname);
	    if (lastname.at(lastname.length() - 1) == '\n')
		lastname.erase(lastname.length() - 1, 1);
	    
	    // Put first and lastname together in one variable
	    
	    wholename = lastname + " " + firstname;
	    
	    flight[num - 1].add(uppercase(wholename));
	    cout << endl << endl << "Name added" << endl << endl;
	    system ("pause");
	    system ("cls");
	    break;
	case 'D':	// Delete name from flight
	    cout << "What flight (1 - 4) : ";
	    cin >> num;
	    
	    // Check for bad data
	    
	    while (!cin || (num < 1 || num > 4))
	    {
		Flush(cin);
		cout << "Enter flight (1 - 4) : ";
		cin >> num;
	    }
	    
	    // End check

	    cout << endl << endl << "Enter name of passenger" << endl
		<< "First name: ";
	    cin.ignore(80, '\n');
	    getline(cin, firstname);
	    if (firstname.at(firstname.length() - 1) == '\n')
		firstname.erase(firstname.length() - 1, 1);
	    cin.ignore(80, '\n');
	    cout << "Last name : ";
	    getline(cin, lastname);
	    if (lastname.at(lastname.length() - 1) == '\n')
		lastname.erase(lastname.length() - 1, 1);
	    
	    wholename = lastname + " " + firstname;
	    
	    flight[num - 1].del(uppercase(wholename));
	    cout << endl << endl << "Name Deleted" << endl << endl;
	    system ("pause");
	    system ("cls");
	    break;
	case 'L':	// List passengers on a flight
	    cout << "What flight (1 - 4) : ";
	    cin >> num;
	    
	    // Check for bad data
	    
	    while (!cin || (num < 1 || num > 4))
	    {
		Flush(cin);
		cout << "Enter flight (1 - 4) : ";
		cin >> num;
	    }
	    
	    // End check

	    cout << endl;
	    flight[num - 1].getlist();
	    cout << endl << endl;
	    system ("pause");
	    system ("cls");
	    break;
	case 'I':	// See number of passengers on a flight
	    cout << "What flight do you want to check (1 - 4) : ";
	    cin >> num;
	    
	    // Check for bad data

	    while (!cin || (num < 1 || num > 4))
	    {
		Flush(cin);
		cout << "Enter flight (1 - 4) : ";
		cin >> num;
	    }
	    
	    // End check

	    cout << endl;
	    flight[num - 1].getnum();
	    cout << endl << endl;
	    system ("pause");
	    system ("cls");
	    break;
	case 'S':	// See passengers on all flights

	    // Start display loop

	    do {	// While counter !=4
		cout << "Flight " << counter + 1 << " :" << endl << endl;
		flight[counter].getlist();
		cout << endl << endl;
		system ("pause");
		counter++;
		system ("cls");
	    } while (counter != 4);

	    // End loop
	    
	    counter = 0;    // Reset counter
	    system ("cls");
	    break;
	case 'Q':	// Quit program
	    menu = 1;		// set menu = 1 to make loop exit
	    cout << "Goodbye" << endl << endl;
	    system ("pause");
	    break;
	default:	// Bad choice switch selection, go to menu
	    cerr << "Invalid choice" << endl << endl;
	    system ("pause");
	    system ("cls");
	}			    // end switch
    } while (menu != 1);
    
    // End main menu selection and main program loop

    return 0;
    
}

// End main

////////////////////////// Subprograms ///////////////////////////////

// Program title and instructions

void instruct()
{
    cout << "        *************************************************************" << endl
	<< "        *                                                           *" << endl
	<< "        *          Wing-and-a-Prayer Airlines Flight System         *" << endl
	<< "        *                                                           *" << endl
	<< "        *************************************************************" << endl << endl << endl
	<< " This program lets you manage 4 flights named 1, 2, 3, and 4" << endl
	<< " You can add, delete, list and see how many people are on a" << endl 
	<< " flight, and get info on a passenger";
}

// End instruct

// Flushes cin stream

inline istream& Flush(istream& stream)
{
    stream.clear();
    int chars_to_skip = stream.rdbuf()->in_avail();
    return stream.ignore(chars_to_skip);
}

// End flush function

// Change string to uppercase

string uppercase(string wholename)
{
    // Go through string and change letters to uppercase as needed

    for (int i = 0; i < wholename.length(); i++)
    {
	if (islower(wholename.at(i)))
	{
	    wholename.replace(i, 1, 1, toupper(wholename.at(i)));
	}
    }

    return wholename;
}

// End function

//////////////////////// End program ///////////////////////////////