#include <fstream.h>
#include <conio.h>
#include <ctype.h>
#include <string.h>
#include <stdlib.h>
#include <iomanip.h>
#include <stdio.h>

class database
 {
  private:
	struct person_rec
	 {
	  char name[30];
	  char grade[2];
	  char score[3];
	 }; // person_rec

	struct node
	 {
	  char name[20];
	  long finish;
	  node *right, *left;
	 }; // node

	node *root, *current, *take_away, *prev;
	fstream outfile, infile;

	int is_empty (node* p);
	void insert_into_file (person_rec new_mem);
	void find_key (char wanted[], int& found);
	void add_to_remaining_entries (node*& p, char name[]);
	int insert_into_list (char name[]);
	long find_name (char wanted[], long first, long last);
	int remove_applicant (char name[], int& deletions);
	void sub_del (node*& q);
	void del (char elem[], node*& p, int& found, int deletions);
	void take_from_remaining_entries (node*& p, char name[], int deletions);
	void delete_from_list (char elem[], int deletions);
	void toss_out (node*& p);

  public:
	database() {root = NULL;};
	void initialize (void);
	int is_empty (void);
	void add_applicant (void);
	void remove_applicant (void);
	void display_same_grade(void);
	void display_same_score(void);
	void display_applicants (void);
	void change_details (void);
	void deallocate_mem (void);
 }; // database

void database::insert_into_file (person_rec new_mem)
// adds the new element to the appropriate location in the file.
 {
  int spot_found = 0;
  person_rec mem;

  infile.open ("a58ass4.dat", ios::in | ios::binary);
  outfile.open ("a58ass4.tmp", ios::out | ios::binary);

  /* transfers the contents of the input file to the output file
	* right up to the point where the insertion needs to be made
	*/

  while (!spot_found && infile.read ((char *) &mem, sizeof (mem)))
	{
	if ((strcmp (new_mem.name, mem.name) < 0) || (strcmp (new_mem.name, mem.name) == 0))
	 {
	  spot_found = 1;
	 }
	else
	 {
	  outfile.write ((char *) &mem, sizeof (mem));
	 } // if 1
	} // while

  // writes the new element to the output file
  outfile.write ((char *) &new_mem, sizeof (new_mem));

  // writes the last read record from the input file to the output file
  if (spot_found)
	{
	 outfile.write ((char *) &mem, sizeof (mem));
	} // if

  // writes the rest of the input file across to the output file
  while (infile.read ((char *) &mem, sizeof (mem)))
	{
	 outfile.write ((char *) &mem, sizeof (mem));
	} // while

  outfile.close ();
  infile.close ();
  remove ("a58ass4.dat");
  rename ("a58ass4.tmp", "a58ass4.dat");
 } // insert_into_file

int database::is_empty (node* p)
// checks whether tree has no numbers in it
 {
  return (p == NULL);
 } // is_empty

int database::is_empty (void)
// checks whether tree has no numbers in it
 {
  return (root == NULL);
 } // is_empty

void database::find_key (char wanted[], int& found)
// searches for the element "wanted" in the tree
 {
  node *p, *prior;

  found = 0;
  if (!is_empty (root))
	{
	 p = root;
	 prev = NULL;
	 do
	  {
		prior = p;
		if (strcmp (wanted, p->name) == 0)
		 {
		  current = p;
		  found = 1;
		 }
		else
		 {
		  if (strcmp (wanted, p->name) < 0)
			{
			 p = p->left;
			}
		  else
			{
			 prev = p;
			 p = p->right;
			} // if
		 } // if
	  }
	 while (!found && p != NULL);
	 if (!found)
	  {
		current = prior;
	  } // if
	} // if
 } // find_key

void database::add_to_remaining_entries (node*& p, char name[])
/* uses the in-order traversal to update the finish locations for the
	remaining nodes in the tree */
 {
  person_rec mem;
  if (p != NULL)
	{
	 add_to_remaining_entries (p->left, name);
	 if (strcmp (p->name, name) > 0)
	  {
		p->finish = p->finish + sizeof (mem);
	  } // if 2
	 add_to_remaining_entries (p->right, name);
	} // if 1
 } // add_to_remaining_entries

int database::insert_into_list (char name[])
/* places "new_num" in the appropriate location for a binary
 * tree in ascending order
 */
 {
  person_rec mem;
  node *p;
  int found;
  int inserted = 0;

  find_key (name, found);
  if (found)
	{
	 current->finish = current->finish + sizeof(mem);
	}
  else
	{
	 p = new node;
	 p->left = p->right = NULL;
	 strcpy (p->name, name);
	 if (is_empty (root))
	  {
		root = p;
		root->finish = sizeof (mem);
	  }
	 else
	  {
		if (strcmp (name, current->name) < 0)
		 {
		  if (prev == NULL)
			{
			 p->finish = sizeof (mem);
			}
		  else
			{
			 p->finish = prev->finish + sizeof (mem);
			} // if 4
		  current->left = p;
		 }
		else
		 {
		  if (prev == NULL)
			{
			 p->finish = sizeof (mem);
			}
		  else
			{
			 p->finish = current->finish + sizeof (mem);
			} // if 4
		  current->right = p;
		 } // if 3
	  } // if 2
	current = p;
	inserted = 1;
	} // if 1
  add_to_remaining_entries (root, name);
  return (inserted);
 } // insert_into_list


///////////////////////////////////////////////////////////////////////////////
//////////////////////////////ADD APPLICANT////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


void database::add_applicant (void)
// Adds a record to the file
 {
  person_rec mem;

  cout << "\nEnter a new applicants name: ";
  cin >> mem.name;
  mem.name[0] = toupper (mem.name[0]);
  cout << "Enter the new applicants score: ";
  cin >> mem.score;
//  mem.score[0] = toupper (mem.first_name[0]);
  cout << "Enter the new applicants grade: ";
  cin >> mem.grade;
  mem.grade[0] = toupper (mem.grade[0]);
  if (is_empty (root))
	{
	 outfile.open ("a58ass4.dat", ios::out | ios::binary);
	 outfile.write ((char *) &mem, sizeof (mem));
	 outfile.close ();
	}
  else
	{
	 insert_into_file (mem);
	} // if 1
  insert_into_list (mem.name);
 } // add_member


///////////////////////////////////////////////////////////////////////////////
//////////////////////////////DISPLAY APPLICANT////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


void database::display_applicants (void)
// Displays the file data in a table
 {
  person_rec mem;

  infile.open ("a58ass4.dat", ios::in | ios::binary);
  cout << "\nNAME           SCORE          GRADE\n";
  cout << "=======================================";
  cout << "=======================================\n";
  while (infile.read ((char *) &mem, sizeof (mem)))
	{
	 cout << setw(20) << setiosflags (ios::left) << mem.name;
	 cout << setw(20) << setiosflags (ios::left) << mem.score;
	 cout << setw(10) << setiosflags (ios::left) << mem.grade << endl;
	} // while
  cout << "\nPress [Enter] to continue: ";
  infile.close ();
  getch();
 } // display_mems

int database::remove_applicant (char name[], int& deletions)
 {
  /* read sequentially through the file, writing each record from the
	* input file to the output file but skipping the record that needs
	* to be removed
	*/
  person_rec mem;
  int is_there = 0;
  char ans;

  deletions = 0;
  infile.open ("a58ass4.dat", ios::in | ios::binary);
  outfile.open ("a58ass4.tmp", ios::out | ios::binary);

  while (infile.read ((char *) &mem, sizeof (mem)))
	{
	 if (strcmp (mem.name, name) != 0)
//    || strcmp (mem.first_name, first_name) != 0)
	  {

	  /* write the record to the output file only if the names are not
		* the same
		*/

		outfile.write ((char *) &mem, sizeof (mem));
	  }
	 else
	  {
		cout << "\nCURRENT DETAILS...\n\n";
		cout << name << " " << mem.score << " " << mem.grade << endl << endl;
		cout << "Are you sure you want to delete this data [Y/N]?";
		is_there = 1;
		while (cin.get() != '\n');
		cin >> ans;
		if (toupper (ans) == 'Y')
		 {
		  deletions = deletions + 1;
		 }
		else
		 {
		  outfile.write ((char *) &mem, sizeof (mem));
		 } // if 2
	  } // if 1
	} // while

  infile.close ();
  outfile.close ();
  remove ("a58ass4.dat");
  rename ("a58ass4.tmp", "a58ass4.dat");
  return (is_there);
 } // remove_from_file

void database::sub_del (node*& q)
/* goes down the right branch until it finds a node that has no
 * children to its right. Isolates that node
 */
 {
  if (q->right != NULL)
	{
	 sub_del (q->right);
	}
  else
	{
	 strcpy (take_away->name, q->name);
	 take_away = q;
	 q = q->left;
	} // if
 } // sub_del

void database::del (char elem[], node*& p, int& found, int deletions)
// finds the element to be deleted and deletes it
 {
  person_rec mem;

  if (p == NULL)
	{
	 found = 0;
	}
  else
	{
	 if (strcmp (elem, p->name) < 0)
	  {
		del (elem, p->left, found, deletions);
	  }
	 else
	  {
		if (strcmp (elem, p->name) > 0)
		 {
		  del (elem, p->right, found, deletions);
		 }
		else
		 {
		  if ((prev == NULL && p->finish == deletions * sizeof (mem)) ||
				(p->finish - prev->finish == deletions * sizeof (mem)))
			{
			 take_away = p;
			 if (p->right == NULL)
			  {
				p = p->left;
			  }
			 else
			  {
				if (p->left == NULL)
				 {
				  p = p->right;
				 }
				else
				 {
				  sub_del (p->left);
				 } // if
			  } // if
			 delete take_away;
			}
		  else
			{
			 p->finish = p->finish - deletions * sizeof (mem);
			} // if
		  found = 1;
		 } // if
	  } // if
	} // if
 } // del

void database::take_from_remaining_entries (node*& p, char name[], int deletions)
/* uses the in-order traversal to update the finish locations for the
	remaining nodes in the tree */
 {
  person_rec mem;
  if (p != NULL)
	{
	 take_from_remaining_entries (p->left, name, deletions);
	 if (strcmp (p->name, name) > 0)
	  {
		p->finish = p->finish - sizeof (mem) * deletions;
	  } // if 2
	 take_from_remaining_entries (p->right, name, deletions);
	} // if 1
 } // take_from_remaining_entries

void database::delete_from_list (char elem[], int deletions)
/* finds the element to be deleted, deletes it and re-adjusts
 * if the tree becomes empty.
 */
 {
  int deleted = 0;
  del (elem, root, deleted, deletions);
  if (deleted)
	{
	 take_from_remaining_entries (root, elem, deletions);
	}
 } // delete_from_list


///////////////////////////////////////////////////////////////////////////////
//////////////////////////////REMOVE APPLICANT/////////////////////////////////
///////////////////////////////////////////////////////////////////////////////


void database::remove_applicant (void)
// removes a user specified person from the database
 {
  char name[20];//, first_name[20];
  int deletions, is_there;

  cout << "Enter name: ";
  cin >> name;
  name[0] = toupper (name[0]);
//  cout << "Enter the first name: ";
//  cin >> first_name;
//  first_name[0] = toupper (first_name[0]);

  is_there = remove_applicant (name, /*first_name,*/ deletions);
  if (deletions)
	{
	 delete_from_list (name, deletions);
	}
  else
	{
	 if (!is_there)
	  {
		cout << "\nERROR:  NAME DOES NOT EXIST IN DATABASE\n\n";
	  } // if 2
	} // if 1
  cout << "Press [Enter] to continue";
  getch ();
 } // remove_person

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////CHANGE DETAILS///////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void database::change_details(void)
{
person_rec mem;
char name[20], ans;
long bytes;

fstream file;

file.open("a58ass4.dat", ios::in | ios::out | ios::binary);

cout << "Enter the name of the student to search for: ";
cin >> name;
bytes = file.tellp();
while(file.read((char *) &mem, sizeof(mem)))
	{
   	if(strcmp(name,mem.name)==0)
      	{
         	cout << "Student Name: " << mem.name << endl;
            cout << "Student score: " << mem.score << endl;
            cout << "Student grade: " << mem.grade << endl;
            cout << "Do you want to change this record [Y/N]? ";
            cin >> ans;

            if(toupper(ans) == 'Y')
            	{
               	cout << "\nEnter New Name: ";
                  cin >> mem.name;
                  cout << "\nEnter New Sore: ";
                  cin >> mem.score;
                  cout << "Enter New Grade: ";
                  cin >> mem.grade;
               file.seekp(bytes, ios::beg);
               file.write((char*) &mem, sizeof(mem));
               }
            }
            bytes=file.tellp();
         }
         file.close();
      }
/*
void database::change_details (void)
// change applicants details
 {
  char name[20], score[5], grade[5], ans;
  int found = 0;
  long f_index;
  person_rec mem;

  cout << "Enter name: ";
  gets(name);
  name[0] = toupper (name[0]);

  // find the position in the array of the specified surname
  find_key (name, found);

  if (!found)
	{
	cout << "\nThis name does not exist in the file.\n";
	}
	 else
	  {
		infile.open ("a58ass4.dat", ios::in | ios::out | ios::binary);
		infile.seekg (f_index, ios::beg);
		while (infile.read ((char *) &mem, sizeof (mem)) &&
				 strcmp (name, mem.name) == 0 )
		 {
		  cout << "\nCURRENT DETAILS...\n\n";
		  cout << name << " " << mem.score << " " << mem.grade << endl << endl;
		  cout << "Do you wish to change these details [Y/N]?";
		  while (cin.get() != '\n');
		  cin >> ans;
		  if (toupper (ans) == 'Y')
			{
          cout << "Enter new name: ";
			 cin >> mem.name;
			 infile.seekg (f_index, ios::beg);
			 infile.write ((char *) &mem, sizeof (mem));

			 cout << "Enter new score: ";
			 cin >> mem.score;
			 infile.seekg (f_index, ios::beg);
			 infile.write ((char *) &mem, sizeof (mem));

          cout << "Enter new grade: ";
			 cin >> mem.score;
			 infile.seekg (f_index, ios::beg);
			 infile.write ((char *) &mem, sizeof (mem));
			}
		  else
			{
			 f_index = f_index + sizeof (mem);
			} // if 3
		 } // while
		infile.close ();
	  } // if 2
	 // if 1
  cout << "\nPress [Enter] to continue: ";
  getch();
 } // change_phone*/

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////SAME GRADE///////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void database::display_same_grade (void)

/* Displays the file data in a table for a given first name.  Reads
 * file sequentially from start to finish, displaying only the
 * required records
 */

 {
  person_rec mem;
  char grade[6];

  infile.open ("a58ass4.dat", ios::in | ios::binary);

  cout << "Enter the grade of the applicants you want to find: ";
  cin >> grade;
  grade[0] = toupper(grade[0]);

  cout << "NAME           SCORE          GRADE\n";
  cout << "=======================================";
  cout << "=======================================\n";
  while (infile.read ((char *) &mem, sizeof (mem)))
	{
	 if (strcmp (grade, mem.grade) == 0)
	  {
		cout << setw(20) << setiosflags (ios::left) << mem.name;
		cout << setw(20) << setiosflags (ios::left) << mem.score;
		cout << setw(10) << setiosflags (ios::left) << mem.grade << endl;
	 } // if
	} // while
  cout << "\nPress [Enter] to continue: ";
  infile.close ();
  getch();
 } // display_same_grade */

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////SAME SCORE/////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void database::display_same_score (void)

/* Displays the file data in a table for a given first name.  Reads
 * file sequentially from start to finish, displaying only the
 * required records
 */

 {
  person_rec mem;
  char score[6];

  infile.open ("a58ass4.dat", ios::in | ios::binary);

  cout << "Enter the score of the applicants you want to find: ";
  cin >> score;
  score[0] = toupper(score[0]);

  cout << "NAME           SCORE          GRADE\n";
  cout << "=======================================";
  cout << "=======================================\n";
  while (infile.read ((char *) &mem, sizeof (mem)))
	{
	 if (strcmp (score, mem.score) == 0)
	  {
		cout << setw(20) << setiosflags (ios::left) << mem.name;
		cout << setw(20) << setiosflags (ios::left) << mem.score;
		cout << setw(10) << setiosflags (ios::left) << mem.grade << endl;
	 } // if
	} // while
  cout << "\nPress [Enter] to continue: ";
  infile.close ();
  getch();
 } // display_same_grade */


void database::initialize (void)
// records the end file locations for each surname in a BST
 {
  person_rec mem;

  infile.open ("a58ass4.dat", ios::in | ios::binary);
  if (infile)
	{
	 while (infile.read ((char *) &mem, sizeof (mem)))
	  {
		insert_into_list (mem.name);
	  }// while
	 infile.close();
	}
  else
	{
	 outfile.open ("a58ass4.dat", ios::out | ios::binary);
	 outfile.close ();
	} // if 1
 } // initialize

void database::toss_out (node*& p)
// uses the pre-order traversal to deallocate each node from memory
 {
  if (!is_empty (p))
	{
	 toss_out (p->left);
	 toss_out (p->right);
	} // if
  delete p;
 } // toss_out

void database::deallocate_mem ()
// stores contents of tree in file
 {
  outfile.open ("a58ass4.dat", ios::out);
  toss_out (root);
  outfile.close();
 } // deallocate_mem

///////////////////////////////////////////////////////////////////////////////
//////////////////////////////MAIN/////////////////////////////////////////////
///////////////////////////////////////////////////////////////////////////////

void main(void)
 {
  int choice;
  int not_finished = 1;
  database directory;

  directory.initialize();
  do // Menu
	{
	 clrscr ();
	 cout << "\nMENU SYSTEM\n";
	 cout << "=============\n\n";
	 cout << "1. Add a new applicant\n";
	 cout << "2. Remove an applicant\n";
	 if (!directory.is_empty ())
	  {
		cout << "3. Display all entries with the same specified grade\n";
		cout << "4. Display all entries with the same specified score\n";
   	cout << "5. Display all applicants\n";
		cout << "6. Change the person's details\n";
		cout << "7. Exit program\n\n";
		cout << "Enter your choice [1-8]: ";
	  }
	 else
	  {
		cout << "3. Exit program\n\n";
		cout << "Enter your choice [1-3]: ";
	  } // if
	 cin >> choice;
	 while (cin.get() != '\n');
	 switch (choice)
	  {
		case 1: directory.add_applicant ();
				  break;
		case 2: directory.remove_applicant ();
				  break;
	  } // switch
	 if (!directory.is_empty ())
	  {
		switch (choice)
		 {
		  case 3: directory.display_same_grade ();
					 break;
		  case 4: directory.display_same_score ();
					 break;
		  case 5: directory.display_applicants ();
					 break;
		  case 6: directory.change_details ();
					 break;
		  case 7: not_finished = 0;
		 } // switch
	  }
	 else
	  {
		if (choice == 3)
		 {
		  not_finished = 0;
		 } // if 2
	  } // if 1
	}
  while (not_finished);
  directory.deallocate_mem ();
 } // a58ass4.cpp

