// Program: a59h2eg5.cpp
// Maintains an ordered, telephone directory system with error checking

#include <fstream.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <iomanip.h>
#include <conio.h>

class linked_list
 {
  private:
	struct pal_rec
	 {
	  char name[30];
     float rate;
	  char title[13];
	  pal_rec* next;
	 };

	pal_rec* head;
	pal_rec* newpal(void);
   pal_rec* recread(fstream &file);

  public:
	linked_list() {head = NULL;}
	void display (void);
	void insert (void);
	void dump (void);
   void read();
   void write();
 }; // linked list

void main(void)
 {
  char choice;
  linked_list list;

  list.read();  // the read function

  do
	{
	cout << "\nLINKED LIST DATABASE - WITHOUT ERROR CHECKING\n";
	cout << "\n[A]dd, [R]emove, [D]isplay or e[X]it: ";
	cin >> choice;
	choice = toupper (choice);
	while (cin.get() != '\n');
	switch (choice)
	 {
	  case 'A': list.insert ();
				break;
	  case 'R': list.dump ();
				break;
	  case 'D': list.display ();
				break;
	 } // switch
	}
  while (choice != 'X');
  list.write();
 } // main

void linked_list::display ()
// display list to screen
 {
  pal_rec* pal;
  pal = head;
  //	if(	(strlen(pal->name)<0) && (strlen(pal->title)<0)		)
 //	{
 //        cout << "List appears to be empty";
 //  }
 //  else
 //'  {
    while (pal != NULL)
	{

		 cout << endl << pal->name << "  " << pal->rate << " " << pal->title;
	  	 pal = pal->next;

	} // while

 cout << "\n";

 } // display

pal_rec* linked_list::newpal(void)
// set up a new record
 {
  pal_rec *pal;

  pal = new pal_rec;
  if (pal != 0)
	{
	 cout << "\n\nEnter Name: ";
	 gets (pal->name);
	 cout << "\nEnter Pay Rate: ";
	 cin >> pal->rate;
    cout << "\nEnter Job Title: ";
    gets(pal->title);
	 pal->next = NULL;
	}
  else
	{
	 cout << "Not enough memory\n";
	} // if
  return (pal);
 } // newpal

void linked_list::insert (void)
// insert a new record into the list
 {
  pal_rec* pal;
  if ((pal = newpal()) != NULL)
	{
	 pal_rec *curr, *prev = NULL;
	 curr = head;
	 while (curr != NULL && strcmp(pal->name, curr->name) > 0)
	  {
		prev = curr;
		curr = curr->next;
	  } // while
	 pal->next = curr;
	 if (prev == NULL)
	  {
		head = pal;
	  }
	 else
	  {
		prev->next = pal;
	  } // if
	}
  else
	{
	 cout << "Can't create new record.\n";
	} // if
 } // insert

void linked_list::dump (void)
// Deletes a record from the list
 {
  char dump_name[30];
  pal_rec *curr, *prev = NULL;

  if (head != NULL)
	{
	 cout << "\n\nName to delete: ";
	 gets (dump_name);
	 curr = head;
	 while (curr != NULL && strcmp(dump_name, curr->name) != 0)
	  {
		prev = curr;
		curr = curr->next;
	  } // while
	 if (curr == NULL)
	  {
		cout << "Name not in list\n";
	  }
	 else
	  {
		if (prev == NULL)
		 {
		  head = curr->next;
		 }
		else
		 {
		  prev->next = curr->next;
		  delete curr;
		 } // if 3
	  } // if 2
	}
  else
	{
	 cout << "\nList is empty.\n";
	} // if 1
 } // dump

void linked_list::read()
{
pal_rec* pal;
	fstream file("a59ass1.dat", ios::in);

   	if(file)
      	{
      	while(!file.eof())
         	{
            	if((pal=recread(file))!=NULL)
               	{
                  	pal_rec *curr, *prev = NULL;
                     curr=head;
                     while(curr!=NULL && strcmp(pal->name, curr->name)>0)
                     	{
                        	prev=curr;
                           curr=curr->next;
                        }//while
                     pal->next=curr;
		 	               if(prev==NULL)
			               	{
			                  	head=pal;
			                  }
		  	               else
			               	{
                				  	prev->next=pal;
       			            }//if
                  }//if
               else
               	{
               cout << "Cannot create record.\n";
               	}//if
            }//while
      }//if1
   file.close();
}//read

void linked_list::write()
{
		pal_rec* pal;
      pal=head;
      fstream file("a59ass1.dat", ios::out);
      	while(pal!=NULL)
         	{
            	file.write((char*)pal,sizeof(*pal));
               pal=pal->next;
            }//while
         file.close();
}//read

pal_rec* linked_list::recread(fstream &file)
{
	pal_rec *pal;

   pal = new pal_rec;
      if(pal!=0)
      	{
         	if(!file.eof())
            	{
               	file.read((char*)pal,sizeof(*pal));
                  	pal->next= NULL;
               }
         }
   	else
   		{
               	cout << "Not enough memory\n";
      	}

   return (pal);
}//recread
