#include <fstream.h>
#include <ctype.h>
#include <string.h>
#include <stdio.h>
#include <conio.h>
#include <iomanip.h>

//Stack example
// by Martin Randall November 2001
void display(char* song,char* artist,char* date);

class stack_class				//define class
{
	private:
	struct pub_house
	{
	char booktitle[30];
	char author[20];
	char date[10];
	pub_house* address;
	};
	pub_house* top, top1;

	public:
	stack_class() {top = NULL;}
	int empty()   {return (top==NULL);}
	void push (char* booktitle,char* author,char* date);
	void pop (char* booktitle,char* author,char* date,int* numrecord);
	void show(char* booktitle,char* author,char* date,int* numrecord);
	};//class def
//--------------------------------------------------------------- push----
void stack_class::push(char* booktitle,char* author,char* date)
{
pub_house* title;

	title = new pub_house;    //create memory for new data structure
	if (title == 0)
	{
		cout<<"\n\t Cannot add record, stack is full.\n\n";
	}
	else
	{
	strcpy(title->booktitle,booktitle);
	strcpy(title->author,author);
	strcpy(title->date,date);
	title->address = top;
	top = title;
	}
 }//push
 //--------------------------------------------------------------- pop ----
	void stack_class::pop(char* booktitle,char* author,char* date, int* numrecord)
		{
		int stacknum;
		pub_house* temp_addr;     //create temporary address
		stacknum = *numrecord;         //no of records

		strcpy(booktitle,top->booktitle);    //extract data
		strcpy(author,top->author);
		strcpy(date,top->date);
		temp_addr = top->address;    //temp address points to next record
		delete top;                // delete top record from memory
		top = temp_addr;             //next record is moved to top of stack
		stacknum = stacknum - 1;
		*numrecord = stacknum;     //update no of records
		};//push
 //--------------------------------------------------------------- show----

	void stack_class::show(char* booktitle,char* author,char* date, int* numrecord)
		{
		int num,stacknum;
		pub_house* t_address;
		pub_house* top1;  	//setup a variable for top of stack
		top1 = top;        //top1 is now same as top
		stacknum= *numrecord;

			for (num=1; num<=stacknum; num++)
			{
			strcpy(booktitle,top1->booktitle);  //copy data from record
			strcpy(author,top1->author);
			strcpy(date,top1->date);
			t_address = top1->address;   //copy address of next record
			top1 = t_address;            //top1 now points to next record
			display(booktitle,author,date);
			}
		} //show records without removing from stack
//--------------------------------------------------------------- header----
 void header()
 {
 clrscr();
 cout<<endl<<"\t"<<setiosflags(ios::left)<<setw(18)<<"SONG:"
 <<setiosflags(ios::left)<<setw(18)<<"ARTIST:"
 <<setiosflags(ios::left)<<setw(10)<<"DATE:\n"<<endl;
 };

//--------------------------------------------------------------- display----
 void display(char* booktitle,char* author,char* date)
 {
 	cout <<"\t"<<setiosflags(ios::left)<<setw(18)<< booktitle;
						cout <<setiosflags(ios::left)<<setw(18)<< author;
						cout <<setiosflags(ios::left)<<setw(10)<< date;
						cout<<endl;
 }
//--------------------------------------------------------------- main ----
  void main(void)
  {
	char booktitle[30];
	char author[20];
	char date[10];
	int numrecord =0,counter=0;
	stack_class stack;

	fstream infile;
	infile.open ("a59ass2.dat",ios::in);
	if (infile)
	{
		while (infile >>booktitle)//get data from file if it exists
		{
			infile >> author;
			infile >> date;
			stack.push(booktitle,author,date);
			numrecord = numrecord+1;
		}
		infile.close();
		cout <<"\n\t Records imported from file: "<<numrecord;
		cout<<endl<<"\n\t Press any key to Continue ";
		getch();
	}
	else
		{
		cout<<endl<<" No file to open ";
		cout<<endl<<" Press any key to Continue ";
		getch();
		}

	char choice;

  do  //user menu
	{
		clrscr();
		cout<< "\n\tA STACK  DATABASE:  MAIN MENU\n";
		cout<< "\t===========================\n"<<endl;
		cout<< "\t1. Add a book \n"<<endl;
		cout<< "\t2. Delete a book\n"<<endl;
		cout<< "\t3. Display a list of all books\n"<<endl;
		cout<< "\t4. Check number of records \n\n";
		cout<< "\t5. EXIT \n"<<endl;
		cout<< "\tEnter your selection [1 - 5] from the Menu: ";
		cin>>choice;

		while (isalpha(choice))
			{
			cout<<endl<<"\tYou have not entered a number ";
			cout<<endl<<"\tPlease re-enter your selection from the Menu ";
			cin>>choice;
			}
		while (cin.get()!='\n');

		switch (choice)
		{
		case '1':   do
						{
						clrscr();
						cout<<endl<<"\n\tEnter booktitle: ";
						gets(booktitle);
						cout<<endl<<"\tEnter author: ";
						gets(author);
						cout<<endl<<"\tEnter date: ";
						gets(date);
						stack.push(booktitle,author,date);
						numrecord = numrecord+1;
						cout <<"\n\t Number of Records is: "<<numrecord;
						cout <<endl<< "\n\n\t Enter another? 'Y' or 'N'";
						}
						while (toupper(getch())=='Y');
						break;
		case '2':
						if (stack.empty())
						cout<<"\n\t Nothing to delete";
						else
						{
						header();
						stack.pop(booktitle,author,date,&numrecord);
						//stack.
						display(booktitle,author,date);
						cout<<"\n\n\t This record has been deleted ";
						}

						break;
		case '3':  {
						header();
						stack.show(booktitle,author,date,&numrecord);
						}
						break;
		case '4':  clrscr();
						cout <<"\n\n\t Number of Records is: "<<numrecord;
						break;

		case '5':  cout<<endl<<"\t Are you sure you want to exit?";
						break;
		}//switch
		cout<<endl<<"\n\tEnter M to return to Main Menu or Q to Quit ";
	}//do
  while (toupper(getch())=='M');
  clrscr();

  fstream outfile;
  outfile.open ("a59ass2.dat",ios::out);

	while (!stack.empty())
	{ 						//delete records from memory & save to file
	stack.pop(booktitle,author,date,&numrecord);
	outfile << booktitle <<"\t";
	outfile << author <<"\t";
	outfile << date <<"\n";
	counter = counter + 1;
  	}
  outfile.close();
  cout<<"\n\n\t"<<counter<<" Records saved to file stack.txt \n";
  cout<<"\n\tthe Stack Database - by Martin Randall"<<endl;

  }; //End of main





