// example of a queue system
// MARTIN RANDALL  november 2001

#include <fstream.h>
#include <stdio.h>
#include <string.h>
#include <conio.h>
#include <ctype.h>
#include <iomanip.h>

class orders //defines class data and functions
{
 private:        //data structure for objects  of class
  struct order_rec
  {
	char date[30];
   char order_no[10];
   char name[30];
   char cost[30];
	struct order_rec* next;
  };

  order_rec *q_in, *q_out,*q_temp, *next1; //pointers to the data structure

  public:
  int numrecord;
  orders() {q_in = NULL; q_out = NULL;}//initialise empty queue
  int empty() {return (q_out == NULL);}//test if queue is empty
  void enque (char *date, char *order_no, char *name, char *cost);//add to queue
  void serve (char *date, char *order_no, char *name, char *cost, int *numrecord);
  void display (char *date, char *order_no, char *name, char *cost);//display data
  void show (char *date, char *order_no, char *name, char *cost, int *numrecord);
  };  //show function will display data without removing from queue
  //this is necessary if the user wants to see the data before saving to
  //file or removing data from the queue
 //--------------------------------------------------------------------
  void orders::enque(char* date, char* order_no, char* name, char *cost)
  {
  order_rec *order;

  order = new order_rec;//finds new memory location for data
  if (order == 0)
  {
	cout << "\n\t Cannot allocate memory for record \n";
  }
  else
  {
	if (q_out == NULL)//is queue empty
	{
	 q_out = order;
	}
	if (q_in != NULL)
	{
	 q_in ->next = order; //q_in next will point to order
	}
	strcpy (order->date,date);
   strcpy (order->order_no,order_no);
	strcpy (order->name,name);
   strcpy (order->cost,cost);
	order->next = NULL;//sets the last node added to point to NULL
	q_in = order; //the end of the queue is the last record entered
	}
  } //enque
//--------------------------------------------------------------------
  void orders::serve(char* date, char* order_no, char* name, char* cost, int* numrecord)
  {
	order_rec* next;
	int record;
	record = *numrecord;//points to record counter

//copies the data from front of queue
	strcpy (date,q_out->date);
   strcpy (order_no,q_out->order_no);
	strcpy (name,q_out->name);
   strcpy (cost,q_out->cost);
	next = q_out->next;//next now points to the second record in queue
	delete q_out;//first record is deleted from memory
	q_out = next;//q_out is now the next record, will become NULL when no
	record = (record - 1);  //records are left
	*numrecord = record;//adjust the record counter
	};//serve
 //--------------------------------------------------------------------
  void orders::show(char* date, char* order_no, char* name, char* cost,int* numrecord)
  {
	orders order;
	order_rec* next;
	order_rec* q_temp;//create a temporary variable for front of queue
	order_rec* next1; //create a temporary variable for the next pointer
	int num,records;
	records = *numrecord;
	q_temp = q_out;//set the temporary variable to point to front of queue

	for (num =1;num <=records; num++)//used instead of while
		{
   strcpy (date,q_temp->date);
   strcpy (order_no,q_temp->order_no);
	strcpy (name,q_temp->name);
   strcpy (cost,q_temp->cost);//copy data from first record in queue
		next1 = q_temp->next;//set to point to next record
		q_temp = next1; //is now the second record

		order.display (date, order_no, name, cost);
		}//data is displayed but not removed from queue

	};//show
 //-------------------------------------------------------------------
//--------------------------------------------------------------------
void orders::display(char* date, char* order_no, char* name, char* cost)
 {
  //orders order;

  cout<<"\nDATE \t ORDER NUMBER \t NAME \t COST \n";
  cout<<"================================================================\n";

  cout << date << "\t\t" << order_no << "\t" << name << "\t" << cost << endl;
 }; //display
 //---------------------------------------------------------------------
 void main(void)
 {

  char choice;
  char date[30];
  char order_no[30];
  char name[30];
  char cost[30];
  int index=0,numrecord=0;
  orders order;

  fstream infile;
  infile.open("a59ass3.dat",ios::in);//open the file

  if (infile) //input data from file if it exists
  {
		while(infile >> date >> order_no >> name >> cost)
		{
		order.enque(date, order_no, name, cost);
		numrecord = numrecord +1;
		} //while

		infile.close();
		cout<<"\n\n\t"<<numrecord<<" Records read from file";
		cout<<"\n\n\t Press any key to continue";
		getch();

	}//if
		else
		{
		cout <<"\n\t NO FILE TO OPEN ";
		cout <<"\n\t Press any key to continue";
		getch();
		}//else

  do //the user menu
  {
  clrscr();
  cout <<"\n\t QUEUE EXAMPLE: \n";
  cout <<"\t =========================== \n";
  cout <<"\n\t 1. ADD an order to the queue \n";
  cout <<"\n\t 2. DELETE an order from the queue \n";
  cout <<"\n\t 3. DISPLAY all orders on the queue \n";
  cout <<"\n\t 4. COUNT No of Records: \n";
  cout <<"\n\t 5. EXIT \n";
  cout <<"\n\t ENTER selection [1 - 5] from Menu: ";
  cin >>choice;

		while (isalpha(choice))//error check
		{
		cout <<"\n\t Please enter a number from 1 -4 ";
		cin  >>choice;
		}//while

  		while (cin.get() != '\n');

  switch (choice)
	{
	case '1': do
			{
			clrscr();
			cout <<"\n\t Enter the date: ";
			gets(date);
			cout <<"\n\t Enter the order number: ";
			gets(order_no);
			cout <<"\n\t Enter the name: ";
			gets(name);
			cout <<"\n\t Enter the cost: ";
			gets(cost);
			order.enque(date, order_no, name, cost);//input data into queue
			numrecord = numrecord + 1;
			cout<<"\n\n\t Number of Records is: "<<numrecord;
			cout<<"\n\n\t Enter another order? 'Y' or 'N' ";
			}//do
			while (toupper(getch())=='Y');
			break;
	case '2':
			{
			if (!order.empty())//is queue empty or not?
			{
			//header();
			order.serve (date, order_no, name, cost, &numrecord);//remove item
			order.display (date, order_no, name, cost);  //from queue
			cout <<"\n\t This order has been deleted from queue ";
			cout <<"\n\n\t Press any key to continue...";
			getch();
			} //if
			else //queue must be empty
			{
			cout <<"\n\t NO ORDERS TO DELETE ";
			} //else
			}//case 2
			break;
	case '3':
			{
			clrscr();
			if(order.empty())//is queue empty?
			{
			cout<<"\n\t NO ORDERS TO DISPLAY ";
			}
			else
			{
			//header();
			order.show (date, order_no, name, cost, &numrecord);//display data from
			}// the queue but do not remove
			}
			break;

	case '4':clrscr();
				cout<<"\n\n\t The Number of records is ";
				cout<<numrecord;
			break;

	case '5': choice ='Q';
			break;

	} //switch
	cout<<"\n\n\t Enter M to return to Menu or Q to Quit ";
	}
	while (toupper(getch())=='M');
	clrscr();
	fstream outfile;
	outfile.open("a59ass3.dat",ios::out);//open file to save data
		while(!order.empty())//remove data from queue, save to file,
		{                     // & free the memory
      order.serve (date, order_no, name, cost ,&numrecord);
		outfile << "\n" << date <<"\t" << order_no << "\t" << name << "\t" << cost;
		cout << numrecord;
		index++;
		}//while
	outfile.close();
	cout <<"\n\n\t "<<index<<" Records have been saved to file a59ass3.dat ";
	cout <<"\n\n\t you have now used the Queue ";
	};













