                          Database File System(DBFS)
                          ==========================

This program works with databases created by it self. This program works as
a command user interface (CUI). Unknown command entries are ignored.  There
are  ten  commands  to  perform  the  different  tasks  with  the database.
It allows user to create database with different structure.  The data types
allowed in this are:
                    a. Character
                    b. Number
                    c. Date
                    d. Logical

Things can be done with this.

        User can add record to  the databases  according  to  the structure
        defined by him.   It  validates  each  and  every type of data of a
        record with respect to the type declared during the creation of the
        database.

        Commands available  to  list all  the  records,  view  the database
        structure,  delete a particular record, locate a particular record,
        remove all records.

CREATE - Command
================
        Function Name   : createdb
        Parameters      : NULL
        Returns         : VOID
        Definition      : void createdb();

        Functional Specification:
                This function  first asks for  the name  of  the  database,
                then it adds ".DBF" extension to  the file name and creates
                the file for writing.

                Then  the user  is  requested  to give  the details for the
                database structure.  The details of the fields are accepted
                in an array.

                The first  two bytes  have  the number  of  fields  in  the
                database.  Then the specifications of the fields like name,
                type and size are stored. Now it adds an integer value ZERO
                at  the end  to  indicate  the  number of  records  in  the
                database.
---------------------------------------------------------------------------

DISPLAY - Command
=================
        Function Name   : displaydb
        Parameters      : FILE Pointer
        Returns         : VOID
        Definition      : void displaydb(FILE *dfp);

        Functional Specification:
                This function displays the structure of the database.   The
                details  displayed  are  the Name, Type  and  Size  of  the
                fields. At first the function checks for  the  FILE pointer
                existence. Then it reads the details from  the database and
                displays.
---------------------------------------------------------------------------

OPEN - Command
==============
        Function Name   : opendb
        Parameters      : Null
        Returns         : FILE Pointer
        Definition      : FILE * opendb();

        Functional Specification:
                This command opens an existing database,  created  by  this
                program only.

                It  first prompts  for  the database file name then it adds
                the .DBF  extension to the filename, opens the database for
                reading and updating. Then returns the file pointer.

                In case the database does not exist,  the function  returns
                NULL automatically.
---------------------------------------------------------------------------

APPEND - Command
================
        Function Name   : addrec
        Parameter       : FILE pointer
        Returns         : VOID
        Definition      : void addrec(FILE *dfp);

        Functional Specification:
                APPEND is used to add records to the database  according to
                its structure.

                First it reads the database for the structure and  then  it
                prompts  the user  for  the relevant  data specified in the
                structure.

                It accepts data after validation the type and size.  As  it
                adds the records to the file  it also updates the number of
                records entry in the database.
---------------------------------------------------------------------------

LIST - Command
==============
        Function Name   : listrec
        Parameter       : FILE Pointer
        Returns : VOID
        Definition      : void listrec(FILE *dfp);

        Functional Specification:
                It reads  the database  and  displays  the records  in  it.
                First it reads the structure of the database. Then it reads
                the integer succeeding the structure details, which has the
                numbers of record entry.

                With respect to the structure details and number of records
                entry, the records are displayed from the same database.

---------------------------------------------------------------------------



LOCATE - Command
================
        Function Name   : locrec
        Parameters      : FILE Pointer
        Returns         : NULL
        Definition      : void locrec(FILE *dfp);

        Functional Specification :
                It receives the FILE pointer and  reads  the file  for  its
                database structure and number of records entry.

                Then it prompts the user for the criteria. (Like Field Name
                and its Value)

                Now the specified field is  searched  for  the given value.
                The located field is displayed.

---------------------------------------------------------------------------

DELETE - Command
================
        Function Name   : delrec
        Parameters      : FILE Pointer & File Name
        Returns         : FILE Pointer
        Definition      : FILE * delrec(FILE *dfp, char *dfname);

        Functional Specification:
                This  command  receives  FILE pointer  and  File  Name.  It
                prompts  the user  for  the Criteria  by which a particular
                record has to be located and deleted.  First  it  reads the
                structure information & creates another temporary file with
                the same structure.

                Now the records,  except one,  which matches  the criteria,
                are  copied  to  the temporary file.  The  actual  file  is
                deleted  and  the temporary file is renamed to the original
                file name. The new file pointer is returned by the function.

---------------------------------------------------------------------------
ZAP - Command
=============
        Function Name   : emptydb
        Parameter       : FILE Pointer & File Name
        Returns         : FILE Pointer
        Definition      : FILE * emptydb(FILE *dfp, char *dfname);

        Functional Specification:
                This command receives  the  File pointer  and  its name.  A
                temporary file  is  created and the actual database file is
                deleted.

                Now the temporary file is renamed by  the actual  file name
                and its pointer is returned.
---------------------------------------------------------------------------
Quit - Command
==============
        This command let the user exits from the  Database File System soon
        after issuing this command.
