#include <stdio.h>
#include <alloc.h>
#include <string.h>

typedef struct _record
{
	char name[15];
	struct _record *next, *prev;
} record, *precord;

precord start = NULL, end=NULL;

precord create()
{
	precord temp;

	temp = (precord) malloc(sizeof(record));

	printf("Please enter the name : ");
	scanf("%s",temp->name);
	temp->next = NULL;
	temp->prev = NULL;

	return temp;
}

bool insert_start()
{
	precord temp;

	temp = create();

	if(temp == NULL)
		return false;

	if(start == NULL)
		start = end = temp;
	else
	{
		temp->next=start;
		start->prev=temp;
		start = temp;
	}
	return true;
}

bool insert_end()
{
	precord temp;

	temp = create();

	if(temp == NULL)
		return false;

	if(start == NULL)
		start = end = temp;
	else
	{
		end->next=temp;
		temp->prev=end;
		end = temp;
	}
	return true;
}

precord locate_record(char *search)
{
	precord temp;
	
	for(temp = start; temp != NULL; temp = temp->next)
	{
		if(strcmp(search,temp->name) == 0)
			return temp;
	}
	return NULL;
}

bool insert_record(char *rec)
{
	precord temp, temp1;

	temp1 = locate_record(rec);

	if(temp1 != NULL)
	{
		if(temp1->next != NULL)
		{
			temp = create();
			if(temp != NULL)
			{
				temp->next = temp1->next;
				temp1->next = temp;
				temp->prev=temp1;
				return true;
			}
			else
			{	return false;  }
		}
		else
		{	return insert_end();   }
	}
	return false;
}

bool delete_start()
{
	precord temp;

	if(start != NULL)
	{
		temp = start;
		if(start->next !=NULL)
		{
			start = start->next;
			start->prev = NULL;
			free(temp);			
		}
		else
		{
			free(start);
			start= end = NULL;
		}
		return true;
	}
	else
		return false;
}

bool delete_end()
{
	precord temp;

	if(start != NULL)
	{
		temp = end;
		if(start->next !=NULL)
		{
			end = end->prev;
			end->next = NULL;
			free(temp);			
		}
		else
		{
			free(temp);
			start= end = NULL;
		}
		return true;
	}
	else
		return false;
}

bool delete_record(char *rec)
{
	precord temp;

	temp = locate_record(rec);

	if(temp != NULL)
	{
		if(temp->next !=NULL)
			temp->next->prev=temp->prev;
		else
			return(delete_end());
		
		if(temp->prev != NULL)
			temp->prev->next=temp->next;
		else
			return(delete_start());
		
		free(temp);
		return true;
	}
	return false;
}

void print()
{
	precord temp;

	for(temp = start; temp != NULL; temp = temp->next)
		printf("%s\n",temp->name);
}


int main()
{
	char nam[15];
	int no_records=0,opt;
	while(1)
	{
		printf("(0) Quit\n"); 
		printf("(1) Insert a name at start of list\n"); 
		printf("(2) Insert a name at end of list\n"); 
		printf("(3) Insert a name after perticular record in list\n"); 
		printf("(4) Delete a name from start of list\n");
		printf("(5) Delete a name from end of list\n");
		printf("(6) Delete a name from list\n");
		printf("(7) Print list\n");
		printf("Enter option : ");
		scanf("%d",&opt);
		switch(opt)
		{
			case 1: 
				if(insert_start())
				{
					printf("Record inserted... \n");
					no_records++;
				}
				else
				{
					printf("Error while inserting record\n");
				}
				break;
			case 2:
				if(insert_end())
				{
					printf("Record inserted... \n");
					no_records++;
				}
				else
				{
					printf("Error while inserting record\n");
				}
				break;
			case 3:
				printf("Please enter the name after which you want to insert new record : ");
				scanf("%s",nam);
				if(insert_record(nam))
				{
					printf("Record inserted... \n");
					no_records++;
				}
				else
				{
					printf("Error while inserting record\n");
				}

				break;
			case 4:
				if(delete_start())
				{
					printf("Record deleted... \n");
					no_records--;
				}
				else
				{
					printf("Error while deleting record\n");
				}
				break;
			case 5:
				if(delete_end())
				{
					printf("Record deleted... \n");
					no_records--;
				}
				else
				{
					printf("Error while deleting record\n");
				}
				break;
			case 6 :
				printf("Please enter the name you want to delete : ");
				scanf("%s",nam);
				if(delete_record(nam))
				{
					printf("Record deleted... \n");
					no_records--;
				}
				else
				{
					printf("Error while deleting record\n");
				}
				break;
			case 7:
				print();
				printf("\nTotal no. of records : %d\n\n",no_records);
				break;
			case 0:
				return 0;
		}
	}
	
}