///////////////////////////////////////////////////////////////////////////////
// Robert Snyder	5/17/01
//
// Description: This program gets input from the user of how many numbers
//              to sort, generates random numbers and places each number 
//              on the heap in min-heap order. As the numbers are deleted 
//              from the heap they are written to a file in the program 
//              directory in accending order.
// Variables:
//           heap[] - an array based heap.
//           data - used to gather the numbers into the heap.
//           last - the last number entered in the heap.
//           val - returned as a reference from the Detete() function
//                 for output.
//           cnt - loop counter.
//           num_to_sort - how many numbers to sort.
//
///////////////////////////////////////////////////////////////////////////////

#include <fstream.h>	// Needed for ofstream object.
#include "heap.h"		// Our heap functions.

void main()
{
	int heap[HEAP_SIZE]={0}; // Initialize the heap and other
	int data=0;				 // variables so we don't get garbage.
	int last=0;
	int val=0;
	int cnt=0;
	int num_to_sort=0;
	
	// Prompt user for input.
	cout << "Enter how many numbers you wish to sort: ";
	cin >> num_to_sort;
	cout << endl;

	// Declare an output file stream object
	// and open the file for output.
	ofstream out_file("heap.out");

	// Get a number for the root of the heap.
	heap[0]=random();

	// Generate and insert numbers untill we have filled up the heap.
	while(cnt<num_to_sort)
	{
		data = random(); // Generate the numbers to be placed on the heap.		
		Insert(heap,last,data); // Insert them onto the heap.
		cnt++; // Increment the counter.
	}
	
	// Display the numbers in the order they were inserted.
	for(int i=0; i<num_to_sort; i++)
		cout << heap[i] << endl;
		
	out_file << "Numbers read as they were deleted: " << endl << endl;

	cnt=0; // Reset the counter.

	// Run through the heap and delete the smallest numbers in order.
	while(cnt<num_to_sort)
	{
		Delete(heap,last,val); // Delete the smallest parent.
		out_file << val << endl; // Write each number to the file.
		cnt++; // Increment the counter.
	}
	out_file << endl << cnt << " numbers generated... " << endl;
	out_file.close(); // Close the file.
}