#include <iostream.h>
#include <time.h>
#include <stdlib.h>
#include "Student.h"

struct linkedList{
	Student s;
	struct linkedList *next;
};

 /*------------------\
| function prototypes |
 \------------------*/
void addNode (void);
void searchMenu (void);
void searchNode (int);
void modifyNode (void);
void deleteNode (void);
void displayAllNodes (void);
void sortNodes (void);
void createNode (Student);
void displayHeader (void);
bool listIsEmpty();

 /*-----------------------\
| global pointer variables |
 \-----------------------*/
struct linkedList *listHead,*currentPtr,*newPtr;


//  Example diagram :list having three nodes.
//
// ListHead keeps track of whole list,while currentPtr is moved 
// around for data manipulation and newPtr can be added to 
// list be setting last nodes pointer to point to newPtr. 
//                
//                                                 *currentPtr                            
//                                                      |
//                                                     \|/
//               /-----------\     /-----------\	 /-----------\               	     /-----------\
//  *listhead-->|  s | *next--+-->|  s | *next--+-->|  s | *next--+--> NULL   *newPtr-->|  s | *next--+--> NULL
//               \-----------/	   \-----------/     \-----------/                       \-----------/
//
 

 /*---------------------------------------\
| main program starts here by showing menu |
 \---------------------------------------*/
void main()
{
	char choice='X',*dateString;

	do
	{
		time_t currentTime;
		currentTime = time(NULL);
		dateString = ctime(&currentTime);
		system("CLS");
		cout <<"\n";
		cout <<"\t\t\t     << My Students's Data >>\n";
		cout <<"\n\t\t\t     Today is ";
		//displays todays date from time string;
		for (int i=0;i<10;i++)cout <<dateString[i];
		cout <<" ";
		for (i=20;i<24;i++)cout <<dateString[i];

		cout <<"\n\n\t\t    ͻ";
		cout <<"\n\t\t     [1] Add new student.                   ";
		cout <<"\n\t\t                                            ";
		cout <<"\n\t\t     [2] Search for a student.              ";
		cout <<"\n\t\t                                            ";
		cout <<"\n\t\t     [3] Modify student marks.              ";
		cout <<"\n\t\t                                            ";
		cout <<"\n\t\t     [4] Delete a student.                  ";
		cout <<"\n\t\t                                            ";
		cout <<"\n\t\t     [5] Sort data in linked list.          ";
		cout <<"\n\t\t                                            ";
		cout <<"\n\t\t     [6] Display entire list.               ";
		cout <<"\n\t\t                                            ";
		cout <<"\n\t\t                    [7] QUIT                ";
		cout <<"\n\t\t    ͼ\n";
		cout <<"\n\t\t      Type in a selection from [1] to [7]: ";
		cin >>(choice);

		switch (choice)
			{
			case '1':addNode();
				break;

			case '2':searchMenu();
				break;

			case '3':modifyNode();
				break;

			case '4':deleteNode();
				break;

			case '5':sortNodes();
				break;

			case '6':displayAllNodes();
				break;

			case '7':cout << "\n\t	 Exiting program......";
				exit(0);

			default: cout << " Invalid Selection";
			}

	}while (choice != '7');
}

  /*------------------------------\
 | create an object of new student | 
 |	and then add the node          |
  \------------------------------*/
void addNode ()
{
	char idString[15],nameString[30],continueAdding='Y';
	
	system("CLS");
	cout << "Add new Student";
	cout << "\n-------------";
	
	do
	{
		while (!cin.get()) {};
		cout << "\nEnter student ID :";
		cin.getline(idString,15);
		strupr(idString);
	
		cout << "Enter student name :";
		cin.getline(nameString,30);
		strupr(nameString);
	
		Student addStudent(idString,nameString);
	
		createNode(addStudent);

		cout << "\nDo you want to add another sutdent? [Y/N] :";
		cin >>continueAdding;
		continueAdding = toupper(continueAdding);
	
	}while (continueAdding!='N');
}

 /*--------------------------\
| display entire linked list  |
 \--------------------------*/
void displayAllNodes ()
{
	if (listIsEmpty())
		return;

	currentPtr = listHead;

	displayHeader();
	
	do //display all in list
	{
		currentPtr->s.display();
		currentPtr = currentPtr->next;

	}
	//until end of list is reached
	while (currentPtr != (struct linkedList *)NULL);

	while (!cin.get()) {};
	while (!cin.get()) {};
}

 /*----------------------------------------------------\
| The header is shown every time record(s) is displayed |
 \----------------------------------------------------*/
void displayHeader()
{
	system("CLS");
	cout << setiosflags(ios::left) << setw(15)<<"\n\nId";
	cout << setw(30)<<" Name "<<setw(6)<<"  Marks";
	cout << setw(15)<<"\n-------------";
	cout << setw(30)<<"------------------------------"<<setw(6)<<" ---------\n\n";

}

 /*---------------------------------------------------------\
| The menu is shown for user to select which field to search |
 \---------------------------------------------------------*/
void searchMenu ()
{

	char choice='X';

	do
	{
		system("CLS");
		cout <<"\n";
		cout <<"\n\t\t              [Students Search]";
		cout <<"\n\n\t\t    ͻ";
		cout <<"\n\t\t     [1] Search by ID.               ";
		cout <<"\n\t\t                                     ";
		cout <<"\n\t\t     [2] Search by name.             ";
		cout <<"\n\t\t                                     ";
		cout <<"\n\t\t     [3] Search by marks.            ";
		cout <<"\n\t\t                                     ";
		cout <<"\n\t\t                [4] RETURN           ";
		cout <<"\n\t\t    ͼ\n";
		cout <<"\n\t\t   Type in a option from [1] to [4]: ";
		cin >>(choice);

		switch (choice)
			{
			case '1':searchNode(1);
				break;

			case '2':searchNode(2);
				break;

			case '3':searchNode(3);
				break;

			case '4':break;

			default: cout << " Invalid Selection";
			}
	}while (choice != '4');
}

 /*-------------------------------\
| search based on ID,name or marks |
 \-------------------------------*/
void searchNode (int a)
{
	char searchString[35];
	int found=0;
	int f;
	
	system("CLS");
	cout << "Student search";
	cout << "\n-------------\n";
	
	if (listIsEmpty())
		return;
	
	if (a==1)
		{
			cout << "\nEnter student ID :";
			while (!cin.get()) {};
			cin.getline(searchString,15);

			displayHeader();
			
			currentPtr = listHead;
			
			do //display all in list
			{
				
				if (currentPtr->s.compare(searchString,1))
				{
					currentPtr->s.display();
					found=1;
				}

				currentPtr = currentPtr->next;
			}
			//until end of list is reached
			while (currentPtr != (struct linkedList *)NULL);

		if (found==0)
			cout << "\n ID not found";
		cout << "\nPress Enter to continue";
		while (!cin.get()) {};
	}

	if (a==2)
		{
			cout << "\nEnter student Name :";
			while (!cin.get()) {};
			cin.getline(searchString,30);
			strupr(searchString);
			
			displayHeader();
			
			currentPtr = listHead;
			
			do //display all in list
			{
				
				if (currentPtr->s.compare(searchString,2))
					{
						currentPtr->s.display();
						found=1;
					}

				currentPtr = currentPtr->next;
			}
			//until end of list is reached
			while (currentPtr != (struct linkedList *)NULL);

			if (found==0)
				cout << "\nName not found";
			
			cout << "\nPress Enter to continue";
			while (!cin.get()) {};
		}

	if (a==3)
		{
			cout << "\nEnter student mark :";
			while (!cin.get()) {};
			cin >> f;

			displayHeader();
			
			currentPtr = listHead;
			
			do //display all in list
			{
				
				if (currentPtr->s.compare(f))
					{
						currentPtr->s.display();
						found=1;
					}

					currentPtr = currentPtr->next;
			}
			//until end of list is reached
			while (currentPtr != (struct linkedList *)NULL);

			if (found==0)
				cout << "\nNot found";
			
			cout << "\nPress Enter to continue";
			while (!cin.get()) {};
			while (!cin.get()) {};
		}	
}

 /*----------------------------\
| edits / give marks to student |
 \----------------------------*/
void modifyNode ()
{
	char searchString[35],reply='N';
	int found=0;
	int value;
	
	system("CLS");
	cout << "Edit student's mark";
	cout << "\n-----------------\n";
	
	if (listIsEmpty())
		return;
	
	cout << "\nEnter student ID :";
	while (!cin.get()) {};
	cin.getline(searchString,15);

	displayHeader();
			
	currentPtr = listHead;
			
	do //display all in list
	{
		if (currentPtr->s.compare(searchString,1))
			{
				currentPtr->s.display();

				cout << "\nIs this the student you want to edit? [Y/N]:";
				cin >> reply;
				reply=toupper(reply);

				if (reply == 'Y')
				{
					do
					{
						cout << "\nEnter marks for this student :";
						cin >> value;
						
						if (value<0 || value>100)
						{
							cout << "Marks cannot be less than 0 or more than 100\n";
						}
						
					}while (value<0 || value>100);

					cout << "\nMarks has been set to " <<value;
					currentPtr->s.setMark(value);
					while (!cin.get()) {};
					while (!cin.get()) {};
				}


				found=1;
			}

		currentPtr = currentPtr->next;
	}
	//until end of list is reached
	while (currentPtr != (struct linkedList *)NULL);

	if (found==0)
	{
		cout << "\n ID not found...";
		cout << "Press Enter to continue";
		while (!cin.get()) {};
	}
}

 /*--------------------------------------------------\
| Deletes nodes by changing pointers to skip the node |
 \--------------------------------------------------*/
void deleteNode ()
{
	char searchString[35],reply='N';
	int found=0,step=0;

	system("CLS");
	cout << "Delete student";
	cout << "\n-------------\n";
	
	if (listIsEmpty())
		return;
	
	cout << "\nEnter student ID :";
	while (!cin.get()) {};
	cin.getline(searchString,15);

	displayHeader();
	
	currentPtr = listHead;
	struct linkedList *prevPtr = (struct linkedList *)NULL;
				
	do //display all in list
	{
		if (currentPtr->s.compare(searchString,1))
			{
				currentPtr->s.display();

				cout << "\nIs this the student you want to delete? [Y/N]:";
				cin >> reply;
				reply=toupper(reply);

				if (reply == 'Y')
				{
					if (step==0)
						listHead = currentPtr->next; //delete first node if found in the first node
					else
						prevPtr->next = currentPtr->next; //delete subsequant node if found in other node
				}


				found=1;
			}

		prevPtr = currentPtr;
		currentPtr = currentPtr->next;
		step++;
	}
	//until end of list is reached
	while (currentPtr != (struct linkedList *)NULL);

	if (found==0)
		cout << "\n ID not found";
	
	cout << "\nPress Enter to continue";
	while (!cin.get()) {};
	while (!cin.get()) {};

}

 /*---------------------------------------------------\
| Sorts by loading entire list into dynamicly crated   |
| array,sort it,and then load it back into linked list |
 \---------------------------------------------------*/
void sortNodes ()
{
    Student temp;
	int counter=0;
	struct linkedList *prevPtr = (struct linkedList*)NULL;
	
	if (listIsEmpty())
		return;

	//move current pointer to begining of list
	currentPtr = listHead;
	
	do //count number of nodes in list
	{
		currentPtr = currentPtr->next;
		counter++; //increment counter
	}
	//until end of list is reached
	while (currentPtr != (struct linkedList *)NULL);

	//create array to store all data from linked list
	Student *sort=new Student[counter];

	//move current pointer back to begining of list
	currentPtr = listHead;
	
	for(int k=0;k<counter;k++)
	{
		//Transfering data into array
		sort[k]=currentPtr->s;
		currentPtr = currentPtr->next;
		
	}
	
	system("CLS");
	cout << "\nSorting by name";
	//selection sort algorithm done on array
	for (int i=0 ; i<counter-1 ; i++)
	{
		for (int j=i;j<counter; j++)
		{
			if (strcmp(sort[i].returnName(),sort[j].returnName()) > 0)
			{
				temp = sort[i];
				sort[i] = sort[j];
				sort[j] = temp;
			}
		}
	}
	
	//linkedList is made empty
	listHead = (struct linkedList*)NULL;

	//data transfered back into linked list one by one
	for(k=0;k<counter;k++)
	{
		createNode(sort[k]);
	}
	
	cout << "...done\n";
	cout << "\nPress Enter to Continue";
	while (!cin.get()) {};
	while (!cin.get()) {};
}

 /*--------------------------------------------\
| creates new nodes to be hooked up to the list |
 \--------------------------------------------*/
void createNode (Student a)
{
	newPtr = new struct linkedList;

	if (listHead == (struct linkedList*)NULL)
		listHead = currentPtr = newPtr;
	else
	{
		currentPtr=listHead;

		while(currentPtr->next != (struct linkedList*)NULL)
			currentPtr=currentPtr->next;

		// link new structure to list
		currentPtr->next=newPtr;
		currentPtr=newPtr;
	}

	currentPtr->s = a;

	currentPtr->next = (struct linkedList*)NULL;
	
}

 /*--------------------------\
| checks if the list is empty |
 \--------------------------*/
bool listIsEmpty()
{
	if (listHead == (struct linkedList *)NULL)
	{
		system("CLS");
		cout << "\nList is empty";
		cout << "...Press enter key to return";
		while (!cin.get()) {};
		while (!cin.get()) {};
		return true;
	}
	else
		return false;
}


