/** Module Name : Queue.Cpp **/
/** Version : 01.00.00 **/
/** Date : 01 / 01 / 2002  **/
/** Description : Defination Of Procedures To Implement Queue
			      Based On Generic Class Node & Queue
				  Defined In Queue.H  **/
/** Implementation : Generation Of Data Strucher By 
                     Dynamic Memory Allocation  **/
/** Author : Vinayak Marwah **/
/** EULA By : New Origin Humans Corporation Limited **/


#include <iostream.h>
#include <conio.h>
#include <assert.h>
#include "Queue.H"


template< class NodeType >
Node< NodeType >::Node()
:Data( NULL ),NextNode( NULL ) {}

/************************************************************************/

template< class NodeType >
Node< NodeType >::Node( NodeType &Value )
:Data( Value ),NextNode( NULL )
{
	cout<<"\n A Node Created Successfully . ";
}

/************************************************************************/

template< class NodeType >
Node< NodeType >::~Node()
{
	cout<<"\n A Node Destroyed Successfully .";
}

/************************************************************************/

template< class NodeType >
Queue< NodeType >::Queue()
:FrontNode( NULL ),RearNode( NULL )
{
	cout<<"\n A Queue Created Successfully .";
}

/************************************************************************/

template< class NodeType >
Queue< NodeType >::~Queue()
{
	cout<<"\n Mission : Destroy A Queue . \n";
	Node< NodeType > *CurrentNode = FrontNode, *TempNode ;
	while( CurrentNode != NULL )
		{
		TempNode = CurrentNode;
		CurrentNode = CurrentNode->NextNode;
		cout<<TempNode->Data<<" , ";
		delete TempNode;
		}
	cout<<"\n Status : Mission Successfull . "
		<<"\n A Queue Destroyed Successfully ."
		<<"\n Press Any Key To Continue ";
	getch();
}

/************************************************************************/

template< class NodeType >
bool Queue< NodeType >::IsEmpty()
{
	if( FrontNode == NULL )
		{
		cout<<"\n No Queue Exists . ";
		return true;
		}
	else
		return false;
}

/************************************************************************/

template< class NodeType >
Node< NodeType > *Queue< NodeType >::CreateNode( NodeType &Value )
{
	Node< NodeType > *NewNode = new Node< NodeType >( Value );
	assert( NewNode != NULL );
	return NewNode ;
}

/************************************************************************/

template< class NodeType >
void Queue< NodeType >::EnQueue( NodeType &Value )
{
	cout<<"\n Operation : Insertion Of A Node At The End Of The Queue .\n";
	Node< NodeType > *NewNode = CreateNode(Value);
	if ( IsEmpty() )
		{
		cout<<"\n Mission : Generating A New Queue . ";
		FrontNode = RearNode = NewNode ;
		}
	else
		{
		RearNode->NextNode = NewNode;
		RearNode = NewNode;
		RearNode->NextNode = NULL;
		}
	cout<<RearNode->Data;
	cout<<"\n Status : Mission SuccessFull ."
		<<"\n Node Inserted At Rear SuccessFully . "
		<<"\n Press Any Key To Continue . ";
	getch();
}

/************************************************************************/

template< class NodeType >
bool Queue< NodeType >::DeQueue()
{
	cout<<"\n Operation : Removal Of A Node From Front Of The Queue .\n";
	if( IsEmpty() )
		{
		cout<<"\n Invalid Operation ."
			<<"\n Status : Mission Failed . "
			<<"\n Press Any Key To Continue . ";
		getch();
		return false;
		}
	else
		{
		Node< NodeType > *CurrentNode = FrontNode;
		if( FrontNode == RearNode )
			FrontNode = RearNode = NULL;
		else
			{
			cout<<"\n Data In The First Node Is : ";
			cout<<CurrentNode->Data;
			FrontNode = FrontNode->NextNode;
			}
		delete CurrentNode;
		cout<<"\n Status : Mission SuccessFull ."
			<<"\n Node Removed From Front Of The Queue Successfully ";
		return true;
		}
		cout<<"\n Press Any Key To Continue . ";
		getch();
}

/************************************************************************/


template< class NodeType >
void Queue< NodeType >::Traverse()
{
	Node< NodeType > *CurrentNode = FrontNode ;
	cout<<"\n Mission : Traversing & Printing A Queue ."
		<<"\n           In Forward Direction ."
		<<"\n The Queue Follows : \n";
	while ( CurrentNode != NULL)
		{
		cout<<CurrentNode->Data<<" , ";
		CurrentNode = CurrentNode->NextNode;
		}
	cout<<"\n Status : Operation Successfull ."
		<<"\n Traversed & Printed Queue Successfully . "
		<<"\n Press Any Key To Continue .";
	getch();
}

/************************************************************************/


template< class NodeType >
int Queue< NodeType >::LenghtOfQueue()
{
	int NosOfNodes = 0 ;
	Node< NodeType > *CurrentNode = FrontNode ;
	cout<<"\n Mission : Traverse & Calculate The Number Of Nodes In A Queue ."
		<<"\n The Single Linked List Follows : \n";
	while ( CurrentNode != NULL)
		{
		NosOfNodes++;
		CurrentNode = CurrentNode->NextNode;
		}
	cout<<"\n Status : Operation Successfull ."
		<<"\n Traversed & Calculated Number Of Nodes In A Queue Successfully . "
		<<"\n Press Any Key To Continue .";
	getch();
	return NosOfNodes;
}

/************************************************************************/