/** Module Name : Queue.H **/
/** Version : 01.00.00 **/
/** Date : 01 / 01 / 2002  **/
/** Description : Defination Of Generic Class Node & Queue **/
/** Implementation : Generation Of Data Strucher By 
                     Dynamic Memory Allocation  **/
/** Author : Vinayak Marwah **/
/** EULA By : New Origin Humans Corporation Limited **/

#ifndef Queue_H
#define Queue_H

template< class NodeType > class Node;          
 /** Generic Class To Define A Node . **/

template< class NodeType > class Queue;          
/** Generic Class To Define A Queue . **/

/************************************************************************************************************************/

template< class NodeType >
class Node
{
	friend class Queue< NodeType >;              
	/** Class Queue Made A Friend To Access Private Data Members Of Class Node . **/

	private :
		NodeType Data;							 
		/** Data Item Of A Node , Of Return Type NodeType . **/	
		
		Node< NodeType > *NextNode;              
		/** Pointer Towards The Succeding Node . **/
		
	public :
		Node();									 
		/** Default Constructor , Initialize A Node . **/
		
		Node( NodeType &Value );				 
		/** Constructor Accepting One Argument To Assign Data To The Node . **/
		
		~Node();                                 
		/** Destructor  , To Destroy A Node . **/
};

/************************************************************************************************************************/

template< class NodeType >
class Queue
{
	private :
		Node< NodeType > *FrontNode;			 
		/** Pointer Towards The First Node Of The Queue . **/
		
		Node< NodeType > *RearNode;              
		/** Pointer Towards The Last Node Of The Queue . **/

	public :
		Queue();          						 
		/** Default Constructor , Initializes A Queue . **/	

		~Queue();                                
		/** Destructor , Destroy The Queue . **/
		
		bool IsEmpty();                          
		/** Function To Assert Wether The Queue Is Empty Or Not . **/
		
		void EnQueue( NodeType &Value );         
		/** Function To Insert A Node , At The End Of The Queue . **/
		
		bool DeQueue();                          
		/** Function To Remove A Node , From The Begining Of The Queue . **/ 
		
		void Traverse();		    			 
		/** Function To Traverse & Print , A Queue From Front To Back . **/	
		
		int LenghtOfQueue();                     
		/** Function To Traverse & Calculate , The Number Of Nodes In A Queue . **/
		
		Node< NodeType > *CreateNode( NodeType &Value ); 
		/** Function To Create & Assign Data To A New Node . **/
};

/************************************************************************************************************************/

#endif

