/** Module Name : SingleLinkList.Cpp **/
/** Version : 01.00.00 **/
/** Date : 01 / 01 / 2002  **/
/** Description : Defination Of Procedures To Implement Single Link List
			      Based On Generic Class Node & SingleLinkList
				  Defined In SingleLinkList.H  **/
/** Implementation : Generation Of Data Strucher By 
                     Dynamic Memory Allocation  **/
/** Author : Vinayak Marwah **/
/** EULA By : New Origin Humans Corporation Limited **/


#include <iostream.h>
#include <conio.h>
#include <assert.h>
#include "Single Link List.H"


template< class NodeType >
Node< NodeType >::Node()
:Data( NULL ),NextNode( NULL ) {}

/************************************************************************/

template< class NodeType >
Node< NodeType >::Node( NodeType &Value )
:Data( Value ),NextNode( NULL )
{
	cout<<"\n A Node Created Successfully . ";
}

/************************************************************************/

template< class NodeType >
Node< NodeType >::~Node()
{
	cout<<"\n A Node Destroyed Successfully .";
}

/************************************************************************/

template< class NodeType >
SingleLinkList< NodeType >::SingleLinkList()
:FirstNode( NULL ),RearNode( NULL )
{
	cout<<"\n A Single Linked List Created Successfully .";
}

/************************************************************************/

template< class NodeType >
SingleLinkList< NodeType >::~SingleLinkList()
{
	cout<<"\n Mission : Destroy A Single Linked List . \n";
	Node< NodeType > *CurrentNode = FirstNode, *TempNode ;
	while( CurrentNode != NULL )
		{
		TempNode = CurrentNode;
		CurrentNode = CurrentNode->NextNode;
		cout<<TempNode->Data<<" , ";
		delete TempNode;
		}
	cout<<"\n Status : Mission Successfull . "
		<<"\n A Single Linked List Destroyed Successfully ."
		<<"\n Press Any Key To Continue ";
	getch();
}

/************************************************************************/

template< class NodeType >
bool SingleLinkList< NodeType >::IsEmpty()
{
	if( FirstNode == NULL )
		{
		cout<<"\n No Single Linked List Exists . ";
		return true;
		}
	else
		return false;
}

/************************************************************************/

template< class NodeType >
Node< NodeType > *SingleLinkList< NodeType >::CreateNode( NodeType &Value )
{
	Node< NodeType > *NewNode = new Node< NodeType >( Value );
	assert( NewNode != NULL );
	return NewNode ;
}

/************************************************************************/

template< class NodeType >
void SingleLinkList< NodeType >::InsertAtFront( NodeType &Value )
{
	cout<<"\n Mission : Insertion Of A Node At The Front Of The Linked List .\n";
	Node< NodeType > *NewNode = CreateNode(Value);
	if ( IsEmpty() )
		{
		cout<<"\n Mission : Generating A New Single Link List . ";
		FirstNode = RearNode = NewNode ;
		}
	else
		{
		NewNode->NextNode = FirstNode;
		FirstNode = NewNode;
		}
	cout<<FirstNode->Data;
	cout<<"\n Status : Mission SuccessFull ."
		<<"\n Node Inserted At Front SuccessFully . "
		<<"\n Press Any Key To Continue . ";
	getch();
}

/************************************************************************/

template< class NodeType >
void SingleLinkList< NodeType >::InsertAtMiddle( NodeType &Value )
{
	cout<<"\n Operation : Insertion Of A Node In The Middle Of The Linked List .\n";
	Node< NodeType > *NewNode = CreateNode(Value);
	if ( IsEmpty() )
		{
		cout<<"\n Mission : Generating A New Single Link List . ";
		FirstNode = RearNode = NewNode ;
		}
	else
		{
		Node< NodeType > *CurrentNode = FirstNode;
		int Middle = (LenghtOfSingleLinkList()/2),Position = 0;
		while( Position != Middle )
			{
			CurrentNode = CurrentNode->NextNode;
			Position++;
			}
		NewNode->NextNode = CurrentNode->NextNode;
		CurrentNode->NextNode = NewNode ;
		}
	cout<<NewNode->Data;
	cout<<"\n Status : Mission SuccessFull ."
		<<"\n Node Inserted In Middle SuccessFully . "
		<<"\n Press Any Key To Continue . ";
	getch();
}

/************************************************************************/

template< class NodeType >
void SingleLinkList< NodeType >::InsertAtRear( NodeType &Value )
{
	cout<<"\n Operation : Insertion Of A Node At The End Of The Linked List .\n";
	Node< NodeType > *NewNode = CreateNode(Value);
	if ( IsEmpty() )
		{
		cout<<"\n Mission : Generating A New Single Link List . ";
		FirstNode = RearNode = NewNode ;
		}
	else
		{
		RearNode->NextNode = NewNode;
		RearNode = NewNode;
		RearNode->NextNode = NULL;
		}
	cout<<RearNode->Data;
	cout<<"\n Status : Mission SuccessFull ."
		<<"\n Node Inserted At Rear SuccessFully . "
		<<"\n Press Any Key To Continue . ";
	getch();
}

/************************************************************************/

template< class NodeType >
bool SingleLinkList< NodeType >::RemoveFromFront()
{
	cout<<"\n Operation : Removal Of A Node From Front Of A Single Linked List .\n";
	if( IsEmpty() )
		{
		cout<<"\n Invalid Operation ."
			<<"\n Status : Mission Failed . "
			<<"\n Press Any Key To Continue . ";
		getch();
		return false;
		}
	else
		{
		Node< NodeType > *CurrentNode = FirstNode;
		if( FirstNode == RearNode )
			FirstNode = RearNode = NULL;
		else
			{
			cout<<"\n Data In The First Node Is : ";
			cout<<CurrentNode->Data;
			FirstNode = FirstNode->NextNode;
			}
		delete CurrentNode;
		cout<<"\n Status : Mission SuccessFull ."
			<<"\n Node Removed From Front Of The Singled Linked List Successfully ";
		return true;
		}
		cout<<"\n Press Any Key To Continue . ";
		getch();
}

/************************************************************************/

template< class NodeType >
bool SingleLinkList< NodeType >::RemoveFromMiddle()
{
	cout<<"\n Operation : Removal Of A Node In The Middle Of The Linked List .\n";
	if( IsEmpty() )
		{
		cout<<"\n Invalid Operation ."
			<<"\n Status : Mission Failed . "
			<<"\n Press Any Key To Continue . ";
		getch();

		return false;
		}
	else
		{
		Node< NodeType > *CurrentNode = FirstNode, *TempNode ;
		int Middle = (LenghtOfSingleLinkList()/2),Position = 0;
		while( Position != Middle )
			{
			CurrentNode = CurrentNode->NextNode;
			Position++;
			}
		TempNode = CurrentNode->NextNode ;
		CurrentNode->NextNode = TempNode->NextNode ;
		cout<<TempNode->Data;
		delete TempNode;
		}

	cout<<"\n Status : Mission SuccessFull ."
		<<"\n Node Removed From Middle SuccessFully . "
		<<"\n Press Any Key To Continue . ";
	getch();
	return true;
}

/************************************************************************/

template< class NodeType >
bool SingleLinkList< NodeType >::RemoveFromRear()
{
	cout<<"\n Operation : Removal Of A Node From Rear Of A Single Linked List .\n";
	if( IsEmpty() )
		{
		cout<<"\n Invalid Operation ."
			<<"\n Status : Mission Failed . "
			<<"\n Press Any Key To Continue . ";
		getch();

		return false;
		}
	else
		{
		Node< NodeType > *TempNode = RearNode;
		if( FirstNode == RearNode )
			FirstNode = RearNode = NULL;
		else
			{
			Node < NodeType > *CurrentNode = FirstNode ;
			while( CurrentNode->NextNode != RearNode )
				CurrentNode = CurrentNode->NextNode ; 
			RearNode = CurrentNode ;
			RearNode->NextNode = NULL;
			}
		cout<<TempNode->Data;
		delete TempNode;
		cout<<"\n Status : Mission SuccessFull ."
			<<"\n Node Removed From Rear Of The Single Linked List Successfully  .";
		return true;
		}
		cout<<"\n Press Any Key To Continue . ";
		getch();
}

/************************************************************************/

template< class NodeType >
void SingleLinkList< NodeType >::Traverse()
{
	Node< NodeType > *CurrentNode = FirstNode ;
	cout<<"\n Mission : Traversing & Printing A Single Linked List ."
		<<"\n           In Forward Direction ."
		<<"\n The Single Linked List Follows : \n";
	while ( CurrentNode != NULL)
		{
		cout<<CurrentNode->Data<<" , ";
		CurrentNode = CurrentNode->NextNode;
		}
	cout<<"\n Status : Operation Successfull ."
		<<"\n Traversed & Printed Single Linked List Successfully . "
		<<"\n Press Any Key To Continue .";
	getch();
}

/************************************************************************/


template< class NodeType >
int SingleLinkList< NodeType >::LenghtOfSingleLinkList()
{
	int NosOfNodes = 0 ;
	Node< NodeType > *CurrentNode = FirstNode ;
	cout<<"\n Mission : Traverse & Calculate The Number Of Nodes In A Single Linked List ."
		<<"\n The Single Linked List Follows : \n";
	while ( CurrentNode != NULL)
		{
		NosOfNodes++;
		CurrentNode = CurrentNode->NextNode;
		}
	cout<<"\n Status : Operation Successfull ."
		<<"\n Traversed & Calculated Number Of Nodes In A Single Linked List Successfully . "
		<<"\n Press Any Key To Continue .";
	getch();
	return NosOfNodes;
}

/************************************************************************/