/** Module Name : Single Link List.H **/
/** Version : 01.00.00 **/
/** Date : 01 / 01 / 2002  **/
/** Description : Defination Of Generic Class Node & SingleLinkList **/
/** Implementation : Generation Of Data Strucher By 
                     Dynamic Memory Allocation  **/
/** Author : Vinayak Marwah **/
/** EULA By : New Origin Humans Corporation Limited **/

#ifndef SingleLinkList_H
#define SingleLinkList_H

template< class NodeType > class Node;           
/** Generic Class To Define A Node . **/

template< class NodeType > class SingleLinkList;
 /** Generic Class To Define A Single Link List . **/

/************************************************************************************************************************/

template< class NodeType >
class Node
{
	friend class SingleLinkList< NodeType >;     
	/** Class SingleLinkList Made A Friend To Access Private Data Members Of Class Node . **/

	private :
		NodeType Data;							 
		/** Data Item Of A Node , Of Return Type NodeType . **/	
		
		Node< NodeType > *NextNode;              
		/** Pointer Towards The Succeding Node . **/
	
	public :
		Node();									 
		/** Default Constructor , Initialize A Node . **/
		
		Node( NodeType &Value );				 
		/** Constructor Accepting One Argument To Assign Data To The Node . **/
		
		~Node();                                 
		/** Destructor  , To Destroy A Node . **/
};

/************************************************************************************************************************/

template< class NodeType >
class SingleLinkList
{
	private :
		Node< NodeType > *FirstNode;			 
		/** Pointer Towards The First Node Of The List . **/
		
		Node< NodeType > *RearNode;              
		/** Pointer Towards The Last Node Of The List **/

	public :
		SingleLinkList();						 
		/** Default Constructor , Initiates A Single Linked List . **/	
		
		~SingleLinkList();                       
		/** Destructor , Destroy The Single Linked List . **/
		
		bool IsEmpty();                          
		/** Function To Assert Wether The List Is Empty Or Not . **/
		
		void InsertAtFront( NodeType &Value );   
		/** Function To Insert A Node , At The Begining Of The List . **/
		
		void InsertAtRear( NodeType &Value );    
		/** Function To Insert A Node , At The End Of The List . **/
		
		void InsertAtMiddle( NodeType &Value );  
		/** Function To Insert A Node , In The Middle Of  The List . **/
		
		bool RemoveFromFront();                  
		/** Function To Remove A Node , From The Begining Of The List . **/ 
		
		bool RemoveFromRear();                   
		/** Function To Remove A Node , From The End Of The List . **/ 
		
		bool RemoveFromMiddle();				 
		/** Function To Remove A Node , From The Middle Of The List . **/
		
		void Traverse();        				 
		/** Function To Traverse & Print , A Linked List From Top To Bottom . **/	
		
		int LenghtOfSingleLinkList();            
		/** Function To Traverse & Calculate , The Number Of Nodes In A List . **/
		
		Node< NodeType > *CreateNode( NodeType &Value ); 
		/** Function To Create & Assign Data To A New Node . **/
};

/************************************************************************************************************************/

#endif

