/** Module Name : Stack.Cpp **/
/** Version : 01.00.00 **/
/** Date : 01 / 01 / 2002  **/
/** Description : Defination Of Procedures To Implement Stack
			      Based On Generic Class Node & Stack
				  Defined In Stack.H  **/
/** Implementation : Generation Of Data Strucher By 
                     Dynamic Memory Allocation  **/
/** Author : Vinayak Marwah **/
/** EULA By : New Origin Humans Corporation Limited **/


#include <iostream.h>
#include <conio.h>
#include <assert.h>
#include "Stack.H"


template< class NodeType >
Node< NodeType >::Node()
:Data( NULL ),PreviousNode( NULL ) {}

/************************************************************************/

template< class NodeType >
Node< NodeType >::Node( NodeType &Value )
:Data( Value ),PreviousNode( NULL )
{
	cout<<"\n A Node Created Successfully . ";
}

/************************************************************************/

template< class NodeType >
Node< NodeType >::~Node()
{
	cout<<"\n A Node Destroyed Successfully .";
}

/************************************************************************/

template< class NodeType >
Stack< NodeType >::Stack()
:BottomNode( NULL ),TopNode( NULL )
{
	cout<<"\n A Stack Created Successfully .";
}

/************************************************************************/

template< class NodeType >
Stack< NodeType >::~Stack()
{
	cout<<"\n Mission : Destroy A Stack . \n";
	Node< NodeType > *CurrentNode = TopNode, *TempNode ;
	while( CurrentNode != NULL )
		{
		TempNode = CurrentNode;
		CurrentNode = CurrentNode->PreviousNode;
		cout<<TempNode->Data<<" , ";
		delete TempNode;
		}
	cout<<"\n Status : Mission Successfull . "
		<<"\n A Stack Destroyed Successfully ."
		<<"\n Press Any Key To Continue ";
	getch();
}

/************************************************************************/

template< class NodeType >
bool Stack< NodeType >::IsEmpty()
{
	if( TopNode == NULL )
		{
		cout<<"\n No Stack Exists . ";
		return true;
		}
	else
		return false;
}

/************************************************************************/

template< class NodeType >
Node< NodeType > *Stack< NodeType >::CreateNode( NodeType &Value )
{
	Node< NodeType > *NewNode = new Node< NodeType >( Value );
	assert( NewNode != NULL );
	return NewNode ;
}

/************************************************************************/

template< class NodeType >
void Stack< NodeType >::Push( NodeType &Value )
{
	cout<<"\n Mission : Insertion Of A Node At The Top Of The Stack .\n";
	Node< NodeType > *NewNode = CreateNode(Value);
	if ( IsEmpty() )
		{
		cout<<"\n Mission : Generating A New Stack . ";
		BottomNode = TopNode = NewNode ;
		BottomNode->PreviousNode = NULL ;
		}
	else
		{
		NewNode->PreviousNode = TopNode;
		TopNode = NewNode;
		}
	cout<<TopNode->Data;
	cout<<"\n Status : Mission SuccessFull ."
		<<"\n Node Inserted At Top SuccessFully . "
		<<"\n Press Any Key To Continue . ";
	getch();
}

/************************************************************************/

template< class NodeType >
bool Stack< NodeType >::Pop()
{
	cout<<"\n Operation : Removal Of A Node From The Top Of A Stack .\n";
	if( IsEmpty() )
		{
		cout<<"\n Invalid Operation ."
			<<"\n Status : Mission Failed . "
			<<"\n Press Any Key To Continue . ";
		getch();
		return false;
		}
	else
		{
		Node< NodeType > *CurrentNode = TopNode;
		if( BottomNode == TopNode )
			BottomNode = TopNode = NULL;
		else
			{
			cout<<"\n Data In The Top Most Node Is : ";
			cout<<CurrentNode->Data;
			TopNode = TopNode->PreviousNode;
			}
		delete CurrentNode;
		cout<<"\n Status : Mission SuccessFull ."
			<<"\n Node Removed From The Top Of A Stack Successfully ";
		return true;
		}
		cout<<"\n Press Any Key To Continue . ";
		getch();
}

/************************************************************************/

template< class NodeType >
void Stack< NodeType >::Traverse()
{
	Node< NodeType > *CurrentNode = TopNode ;
	cout<<"\n Mission : Traversing & Printing A Stack ."
		<<"\n           In Top-Bottom Direction ."
		<<"\n The Stack Follows . \n";
	while ( CurrentNode != NULL)
		{
		cout<<CurrentNode->Data<<" , ";
		CurrentNode = CurrentNode->PreviousNode;
		}
	cout<<"\n Status : Operation Successfull ."
		<<"\n Traversed & Printed Stack Successfully . "
		<<"\n Press Any Key To Continue .";
	getch();
}

/************************************************************************/


template< class NodeType >
int Stack< NodeType >::LenghtOfStack()
{
	int NosOfNodes = 0 ;
	Node< NodeType > *CurrentNode = TopNode ;
	cout<<"\n Mission : Traverse & Calculate The Number Of Nodes In A Stack .";
	while ( CurrentNode != NULL)
		{
		NosOfNodes++;
		CurrentNode = CurrentNode->PreviousNode;
		}
	cout<<"\n Status : Operation Successfull ."
		<<"\n Traversed & Calculated Number Of Nodes In A Stack . "
		<<"\n Press Any Key To Continue .";
	getch();
	return NosOfNodes;
}

/************************************************************************/