/** Module Name : Stack.H **/
/** Version : 01.00.00 **/
/** Date : 01 / 01 / 2002  **/
/** Description : Defination Of Generic Class Node & Stack **/
/** Implementation : Generation Of Data Strucher By 
                     Dynamic Memory Allocation  **/
/** Author : Vinayak Marwah **/
/** EULA By : New Origin Humans Corporation Limited **/

#ifndef Stack_H
#define Stack_H

template< class NodeType > class Node;           
/** Generic Class To Define A Node . **/

template< class NodeType > class Stack;          
/** Generic Class To Define A Stack . **/

/************************************************************************************************************************/

template< class NodeType >
class Node
{
	friend class Stack< NodeType >;              
	/** Class Stack Made A Friend To Access Private Data Members Of Class Node . **/

	private :
		NodeType Data;							 
		/** Data Item Of A Node , Of Return Type NodeType . **/	
		
		Node< NodeType > *PreviousNode;          
		/** Pointer Towards The Preceding Node . **/
		
	public :
		Node();									 
		/** Default Constructor , Initialize A Node . **/
		
		Node( NodeType &Value );				 
		/** Constructor Accepting One Argument To Assign Data To The Node . **/
		
		~Node();                                 
		/** Destructor  , To Destroy A Node . **/
};

/************************************************************************************************************************/

template< class NodeType >
class Stack
{
	private :
		Node< NodeType > *BottomNode;			 
		/** Pointer Towards The Bottom Most Node Of The Stack . **/
		
		Node< NodeType > *TopNode;               
		/** Pointer Towards The Top Most Node Of The Stack . **/

	public :
		Stack();         						 
		/** Default Constructor , Initializes A Single Linked List . **/	
		
		~Stack();                                
		/** Destructor , Destroy The Single Linked List . **/
		
		bool IsEmpty();                          
		/** Function To Assert Wether The Stack Is Empty Or Not . **/
		
		void Push( NodeType &Value );            
		/** Function To Insert A Node , At The Top Of A Stack . **/
		
		bool Pop();                              
		/** Function To Remove A Node , From The Top Of A Stack . **/ 
		
		void Traverse();	    				 
		/** Function To Traverse & Print , A Stack From Top To Bottom . **/	
		
		int LenghtOfStack();                     
		/** Function To Traverse & Calculate , The Number Of Nodes In A Stack . **/
		
		Node< NodeType > *CreateNode( NodeType &Value ); 
		/** Function To Create & Assign Data To A New Node . **/
};

/************************************************************************************************************************/

#endif

